CREATE OR REPLACE FUNCTION ARQUIVO_DCTF_R30 (
   P_CDLIVROMAG   IN LIVROMAGNETICO.CDLIVROMAG%TYPE,
   P_CDEMPRESA    IN EMPRESA.CDEMPRESA%TYPE,
   P_DTINICIAL    IN NOTAFISCAL.DTENTRSAID%TYPE,
   P_DTFINAL      IN NOTAFISCAL.DTENTRSAID%TYPE,
   P_NRSEQARQMAG  IN ARQMAGNETICO.NRSEQARQMAG%TYPE,
   P_SITUACAO     IN NOTAFISCAL.IDSTATUS%TYPE,
   V_IRPJ         VARCHAR2,
   V_IRRF         VARCHAR2,
   V_IPI          VARCHAR2,
   V_IOF          VARCHAR2,
   V_CSLL         VARCHAR2,
   V_PIS          VARCHAR2,
   V_COFINS       VARCHAR2,
   V_CPMF         VARCHAR2,
   V_CIDE         VARCHAR2,
   V_RET          VARCHAR2,
   V_CSRF         VARCHAR2,
   V_COSIRF       VARCHAR2,
   V_CPSSS        VARCHAR2)RETURN NUMBER
AS 
   V_CONTREGAR30   NUMBER;
   V_CDRECEITA    VARCHAR2(6);
BEGIN
   FOR C_REG_30_IRPJ IN (SELECT (RPAD('R30',3,' '))                                                                          ||/*REGISTRO*/
                                LPAD(REPLACE(REPLACE(REPLACE(REPLACE(NRINSJUREMPR,'.',''),'-',''),'/',''),' ',''),14,0)      ||/*CNPJ*/
                                TO_CHAR(P_DTINICIAL,'YYYYMM')                                                                ||/*ANO/MES*/
                                P_SITUACAO                                                                                   ||/*SITUACAO*/
                                DECODE(P_SITUACAO,'0',RPAD('0',8,'0'), TO_CHAR(TO_DATE(P_DTINICIAL),'YYYYMMDD'))             ||/*DATA DO EVENTO*/
                                V_IRPJ                                                                                       ||/*TRIBUTO*/
                                NVL(NVL(CDRECEITACONTR,CDRECEGUIA)||CDVARIACAO,'000000')                                     ||/*CDIGO DA RECEITA*/
                                IDPERIODICREC                                                                                ||/*PERIODICIDADE*/
                                TO_CHAR(DTFIMPERIODO,'YYYY')                                                                  ||/*ANO DE APURAO*/
                                DECODE(TO_CHAR(DTFIMPERIODO,'MM'),'03','01',DECODE(TO_CHAR(DTFIMPERIODO,'MM'),'06','02',DECODE(TO_CHAR(DTFIMPERIODO,'MM'),'09','03','04')))||/*TRIMESTRE*/
                                '00'                                                                                         ||/*RESERVADO*/
                                RPAD('0',6,'0')                                                                              ||/*RESERVADO*/
                                RPAD('0',14,'0')                                                                             ||/*RESERVADO*/
                                NVL(CDOBRIGAGUIA,0)                                                                          ||/*N DA QUOTA*/
                                RPAD(' ',10,'0')    AS REG_30_IRPJ                                                             /*RESERVADO*/
                           FROM (SELECT SUM(ROUND(NVL(G.VRTOTALGUIACOMP,G.VRRECEITAGUIA),2)) AS VRDEBITO, E.NRINSJUREMPR,
                                        CDRECEITACONTR,G.CDRECEITAGUIA,G.DTVENCGUIACOMPL,G.VRRECEITAGUIA, G.VRMULTAGUIACOMP,
                                        G.VRJUROSGUIACOMP,  IDGUIAIMPR, CDVARIACAO,IDPERIODICREC, CDOBRIGAGUIA,
                                        MAX(MP.DTFIMPERIODO) AS DTFIMPERIODO, CDRECEGUIA
                                   FROM EMPRESA E, MAPAAPURAC MP , GUIACOMPLMAPA G
                                  WHERE E.CDEMPRESA     = P_CDEMPRESA
                                    AND E.CDEMPRESA     = MP.CDEMPRESA
                                    AND MP.CDIMPOSTO    = '25'
                                    AND TO_CHAR(TO_DATE(P_DTFINAL),'MM') IN ('03','06','09','12')
                                    AND MP.DTINIPERIODO = ADD_MONTHS(P_DTINICIAL,-5)
                                    AND MP.DTFIMPERIODO = ADD_MONTHS(P_DTFINAL,-3)
                                    AND MP.NRSEQUMAPAPU = G.NRSEQUMAPAPU
                                  GROUP BY E.NRINSJUREMPR,CDRECEITACONTR,G.CDRECEITAGUIA,G.DTVENCGUIACOMPL,G.VRRECEITAGUIA,
                                        G.VRMULTAGUIACOMP,G.VRJUROSGUIACOMP, CDOBRIGAGUIA,NVL(G.VRTOTALGUIACOMP,G.VRRECEITAGUIA),
                                        IDGUIAIMPR, CDVARIACAO,IDPERIODICREC, CDRECEGUIA))LOOP
      V_CONTREGAR30 := NVL(V_CONTREGAR30,0)+1;
      INSERT INTO ARQMAGNETICO
         (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
      VALUES
         ('2043'||LPAD(RTRIM(V_CONTREGAR30), 8, '0'), C_REG_30_IRPJ.REG_30_IRPJ, P_NRSEQARQMAG);
   END LOOP;

   FOR C_REG_30_CSLL IN (SELECT (RPAD('R30',3,' '))                                                                          ||/*REGISTRO*/
                                LPAD(REPLACE(REPLACE(REPLACE(REPLACE(NRINSJUREMPR,'.',''),'-',''),'/',''),' ',''),14,0)      ||/*CNPJ*/
                                TO_CHAR(P_DTINICIAL,'YYYYMM')                                                                ||/*ANO/MES*/
                                P_SITUACAO                                                                                   ||/*SITUACAO*/
                                DECODE(P_SITUACAO,'0',RPAD('0',8,'0'), TO_CHAR(TO_DATE(P_DTINICIAL),'YYYYMMDD'))             ||/*DATA DO EVENTO*/
                                V_CSLL                                                                                       ||/*TRIBUTO*/
                                NVL(NVL(CDRECEITACONTR,CDRECEGUIA)||CDVARIACAO,'000000')                                     ||/*CDIGO DA RECEITA*/
                                IDPERIODICREC                                                                                ||/*PERIODICIDADE*/
                                TO_CHAR(DTFIMPERIODO,'YYYY')                                                                 ||/*ANO DE APURAO*/
                                DECODE(TO_CHAR(DTFIMPERIODO,'MM'),'03','01',DECODE(TO_CHAR(DTFIMPERIODO,'MM'),'06','02',DECODE(TO_CHAR(DTFIMPERIODO,'MM'),'09','03','04')))||/*TRIMESTRE*/
                                '00'                                                                                         ||/*RESERVADO*/
                                RPAD('0',6,'0')                                                                              ||/*RESERVADO*/
                                RPAD('0',14,'0')                                                                             ||/*RESERVADO*/
                                NVL(CDOBRIGAGUIA,0)                                                                          ||/*N DA QUOTA*/
                                RPAD(' ',10,'0')    AS REG_30_CSLL                                                             /*RESERVADO*/
                           FROM (SELECT SUM(ROUND(NVL(G.VRTOTALGUIACOMP,G.VRRECEITAGUIA),2)) AS VRDEBITO, E.NRINSJUREMPR,
                                        CDRECEITACONTR,G.CDRECEITAGUIA,G.DTVENCGUIACOMPL,G.VRRECEITAGUIA, G.VRMULTAGUIACOMP,
                                        G.VRJUROSGUIACOMP,  IDGUIAIMPR, CDVARIACAO,IDPERIODICREC, CDOBRIGAGUIA,
                                        MAX(MP.DTFIMPERIODO) AS DTFIMPERIODO, CDRECEGUIA
                                   FROM EMPRESA E, MAPAAPURAC MP , GUIACOMPLMAPA G
                                  WHERE E.CDEMPRESA     = P_CDEMPRESA
                                    AND E.CDEMPRESA     = MP.CDEMPRESA
                                    AND MP.CDIMPOSTO    = '70'
                                    AND TO_CHAR(TO_DATE(P_DTFINAL),'MM') IN ('03','06','09','12')
                                    AND MP.DTINIPERIODO = ADD_MONTHS(P_DTINICIAL,-5)
                                    AND MP.DTFIMPERIODO = ADD_MONTHS(P_DTFINAL,-3)
                                    AND MP.NRSEQUMAPAPU = G.NRSEQUMAPAPU
                                  GROUP BY E.NRINSJUREMPR,CDRECEITACONTR,G.CDRECEITAGUIA,G.DTVENCGUIACOMPL,G.VRRECEITAGUIA,
                                        G.VRMULTAGUIACOMP,G.VRJUROSGUIACOMP,CDOBRIGAGUIA,NVL(G.VRTOTALGUIACOMP,G.VRRECEITAGUIA),
                                        IDGUIAIMPR,CDVARIACAO,IDPERIODICREC, CDRECEGUIA))LOOP
      V_CONTREGAR30 := NVL(V_CONTREGAR30,0)+1;
      INSERT INTO ARQMAGNETICO
         (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
      VALUES
         ('2103'||LPAD(RTRIM(V_CONTREGAR30), 8, '0'), C_REG_30_CSLL.REG_30_CSLL, P_NRSEQARQMAG);
   END LOOP;
   RETURN V_CONTREGAR30 ;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('ARQUIVO_DCTF_R30','5.03.034'); END;
/